/***********
 This module is provided as an example of creating a Node PACKAGE, which could be published to NPM.

 Any modules within subfolders should be made into packages *create a package.json, e.g. by running 'npm init' in the directory).
 Otherwise NPM may clean up subfolders when running npm commands.
 **********/
const omnis_calls = require('omnis_calls');
http = require('http');
https = require('https');
const crypto = require('crypto')
const fs = require('fs');
const os = require('os');
const path = require('path');
/**
 * Implement all of your publicly accessible methods in methodMap.
 */
const methodMap = {

    processLogos: function(param, response) {

        //download logos
        function downloadFile(logoID){
            let file = fs.createWriteStream(param.C1+"LogoCDM_"+logoID+"_545x204.png");
            https.get("https://logos.suran.com/cdm/LogoCDM_"+logoID+"_545x204.png", function(resp) {
                resp.pipe(file);
                file.on('finish', function() {
                    file.close();
                });
            });
        }

        //delete logos
        function deleteFile(logoID){
            var path = param.C1+"LogoCDM_"+logoID+"_545x204.png";
            try {
                fs.unlinkSync(path)
              } catch(err) {
                console.error(err)
              }
        }

        //downloads a new manifest
        function getManifest(){
            let file2 = fs.createWriteStream(param.C1+"manifest.json");
            request = https.get("https://logos.suran.com/cdm/catalog.json", function(res) {   
                res.pipe(file2);
                file2.on('finish', function() {
                    logoActions()
                    file2.close();
                })
            });
        }
        
        getManifest()

        //get array of currently downloaded logos
        function findFilesInDir(startPath){
            var results = [];
            if (!fs.existsSync(startPath)){
                return;
            }
            var files=fs.readdirSync(startPath);
            for(var i=0;i<files.length;i++){
                if(files[i] != "manifest.json" && files[i] != ".DS_Store"){
                    temp = files[i];
                    temp = temp.split("_");
                    results.push(temp[1]);
                }
            }
            return results;
        } 

        //convert manifest to list
        function convertManifest(){
            var manifestLogoID = new Array;
            manifest = fs.readFileSync(param.C1+'manifest.json');
            manifestList = JSON.parse(manifest);
            return manifestList;
        }

        //compare manifest with downloaded logos
        function getDeleteList(manifestLogos, currentLogos){
            var deleteList = new Array;
            for(var i = 0; i<currentLogos.length; i++){
                if(manifestLogos.filter(item => item.id === parseInt(currentLogos[i])).length == 0){
                    deleteFile(currentLogos[i]);
                }
                else if(manifestLogos.filter(item => item.checksum === String(generateChecksum(currentLogos[i]))).length == 0){
                    downloadFile(currentLogos[i])
                }
            }
        }
        function getDownloadList(manifestLogos, currentLogos){
            var downloadList = new Array;
            for(var i = 0; i<manifestLogos.length; i++){
                if(!(currentLogos.includes((manifestLogos[i].id).toString()))){
                    downloadFile(manifestLogos[i].id)
                }   
            }
        }

        function logoActions(){
            var manifestLogos = convertManifest();
            var currentLogos = findFilesInDir(param.C1);
            getDeleteList(manifestLogos,currentLogos);
            getDownloadList(manifestLogos,currentLogos);
        }

        //checksum
        function generateChecksum(logoID){
            files = fs.readFileSync(param.C1+"LogoCDM_"+logoID+"_545x204.png");
            const sha1sum = crypto.createHash('sha256').update(files).digest("hex");
            return sha1sum;
        }
    }
};

module.exports = {
    call: function (method, param, response) { // The only requirement of an Omnis module is that it implement this function.

        autoSendResponse = true;

        if (methodMap[method]) {
            const result = methodMap[method](param, response);
            if (autoSendResponse)
                omnis_calls.sendResponse(result, response);
            return true;
        }
        else {
            throw Error("Method '" + method + "' does not exist");
        }

    }
};